/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sample1.c,v 1.23 2007/03/27 08:55:29 hiro Exp $
 */

/* 
 *  ץץ(1)
 *
 *  JSPͥδŪưǧ뤿Υץץࡥ
 *
 *  ץγ:
 *
 *  桼󥿥եĥᥤ󥿥ʥID: MAIN_TASK
 *  ͥ: MAIN_PRIORITYˤȡĤ¹Ԥ륿ʥID:
 *  TASK1TASK3ͥ: MID_PRIORITYˤǹ롥ޤư
 *  2äμϥɥʼϥɥID: CYCHDR1ˤѤ롥
 *
 *  ¹Ԥ륿ϡtask_loop 롼פ¹Ԥ٤ˡ
 *  ¹Ǥ뤳Ȥ򤢤魯åɽ롥
 *
 *  ϥɥϡĤͥ١HIGH_PRIORITYMID_PRIORITY
 *  LOW_PRIORITYˤΥǥ塼ž롥ץεưľϡ
 *  ϥɥ߾֤ˤʤäƤ롥
 *
 *  2011/2 change CFV2 to CFV1 By Fujisekk LTD */

#include "t_services.h"
#include "kernel_id.h"
#include "sample1.h"
#include "ledapp.h"
#include <MCF51JM128.h>
#include "adc.h"
#define  Vcharged 0x977
//unsigned short ReadADC(byte channel);
/*
 *  ¹Լ¹Ԥ륿ؤΥåΰ
 */
char	message[3];

/*
 *  롼ײ
 */
UW	task_loop;		/* ǤΥ롼ײ */
UW	tex_loop;		/* 㳰롼ǤΥ롼ײ */
UW	counter; //???test
UW	counter1; //???test
/* ܸ */
/*If USB Power Batt Charging           *
 * return 0 Low 1 Chargeing 2 Cherge UP*/
char enevleBattCharg(void){
//word adcresult;
unsigned long adcresult;
   if(MC3467X_PPR==0){
    /* PORTG */
   	 	MC3467X_EN = 0; /* Enable battery charging */
		adcresult =readADC(7);      //test CH0
		if(adcresult >= Vcharged){
			   PTFD_PTFD1= ON; /* Turn on GREEN LED */
			   return(2);
		}else{
			PTFD_PTFD1=~PTFD_PTFD1 ; /* Invert GREEN LED */
			   return(1);
		}
   }else{
    MC3467X_EN = 1; /* Disable battery charg */
    PTFD_PTFD1= OFF; /* Turn off GREEN LED */
			   return(0);
   }

}
/* SD-Memory Card Insert&Protect Check  */
/* RET 0 No ,1 Protect ,2 Write Eneble  */
char sd_card_check(void)
{
   unsigned char input;
      input=PTFD;
          if(!(input&0x08)){
             if(input&0x010){
                        PTFD_PTFD0=~PTFD_PTFD0;
            return(1);
                         }else{
                PTFD_PTFD0 =0 ;   
                                return(2);
             }
          }else{
            PTFD_PTFD0 = 1;  
                        return (0);
          }
}
 /* Clear the interrupt flag */

/*
 *  ¹Լ¹Ԥ륿
 */
void task(VP_INT exinf)
{
		initADC();

	for (;;) {
	counter1 = counter1 +1;
		if (counter1 >= 1024) {
//			counter1 = 0;
		   enevleBattCharg();
			wup_tsk(MAIN_TASK);
		  tslp_tsk (2);
		}
	}
}

/*
 *  ¹ԤƼ¹Ԥ륿ѤΥ㳰롼
 */

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
int i = 0;
act_tsk(TASK1);
counter = 0;
	for (;;) {
	counter = counter +1;

		if (counter >= 624) {
		counter = 0;
	  __RESET_WATCHDOG(); /* feeds the dog */
		slp_tsk();
		}
	}
}

void kernel_cpuexc_handler(VP p_excinf){
		;
}

